//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include "iostream.h"
#include<math.h>

#include "programator.h"
//#include "Nastaveni.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
int pole[16384];
//int n=0;

DCB dcb;
_COMMTIMEOUTS Timer;
HANDLE hCOM=NULL;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//----------------------------------------------------------------------------
int Write_UART(int *buffer,unsigned long pocet)
{
  unsigned long nacteno=0;
      WriteFile(hCOM , buffer, pocet , &nacteno , 0);
  return(nacteno);
}
//----------------------------------------------------------------------------
void Open_UART(unsigned char port)
{
   AnsiString UP;
   switch(port)
   {
      case 0:
         UP="COM1";
      break;
      case 1:
         UP="COM2";
      break;

      case 2:
         UP="COM3";
      break;

      case 3:
         UP="COM4";
      break;

      case 4:
         UP="COM5";
      break;

      default:

      break;
   }
   hCOM = CreateFile(UP.c_str(),
                GENERIC_READ | GENERIC_WRITE,
                0,
                NULL,
                OPEN_EXISTING,
                0,
                NULL);
//test otevreni portu
   if (hCOM == INVALID_HANDLE_VALUE)
   {
      MessageDlg("COM nelze otevt",mtError,TMsgDlgButtons()<<mbYes, 0);
      exit(0);
   }
   //zjisteni nastaveni portu
   if ( !GetCommState(hCOM, &dcb) )
   {
      MessageDlg("Chyba linky",mtWarning,TMsgDlgButtons()<<mbYes, 0);
        exit(0);
   }
   dcb.BaudRate=19200;
   dcb.Parity=0;
   dcb.ByteSize=8;
   dcb.StopBits=0;
//nastaveni vlastnosti portu
   SetCommState(hCOM, &dcb);
//nacteni casovacich dob portu
   GetCommTimeouts(hCOM, &Timer);
   Timer.ReadTotalTimeoutMultiplier=10;
   Timer.ReadTotalTimeoutConstant=10;
   Timer.WriteTotalTimeoutMultiplier=10;
   Timer.WriteTotalTimeoutConstant=10;
   SetCommTimeouts(hCOM, &Timer);
}
//---------------------------------------------------------------------------
String Prevod_ost(int cislo_prevadene,int soustava)  //funkce pevodu sla z destkov na ostatn souistavy
{
int celek,i,delenec;
String text;
      for(i=0;i<=128;i++)
         if ((cislo_prevadene/(pow(soustava,i)))<soustava)
            break;
      if (i==0) text="0";
      for(i;i>0;i--)
      {
         delenec=pow(soustava,i);
         celek=cislo_prevadene/delenec;
         cislo_prevadene=cislo_prevadene % delenec;
         if (celek<10)
            text=text+IntToStr(celek);
         else
         {
            text=text+char(55+celek);
         }
      }
      if (cislo_prevadene<10)
            text=text+IntToStr(cislo_prevadene);
      else
            text=text+char(55+cislo_prevadene);
      return(text);
}
//---------------------------------------------------------------------------
int Prevod_deka (int soustava,String cislo) //pevod sla na destkovou soustavu
{
int delka,vysledek;
        delka = (cislo.Length());
        vysledek=0;
        for (int i=delka; i>0; i--)
        {
           if (cislo[i]>='A')
              vysledek=vysledek+((int(cislo[i])-55)*pow(soustava,delka-i));
           else
              vysledek=vysledek+((StrToInt(cislo[i]))*pow(soustava,delka-i));
        }
   return(vysledek);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Init(TObject *Sender)
{
int delka;

for (int i=0;i<256;i++)
   SData->Cells[0][i]="3000";
for (int i=0;i<256;i++)
   {
      delka=Prevod_ost(i*16,16).Length();
      SData->Cells[0][i]=SData->Cells[0][i].Delete(5-delka,4);
      SData->Cells[0][i]=SData->Cells[0][i].Insert(Prevod_ost(i*16,16),5-delka);
      for(int j=1;j<18;j++)
         SData->Cells[j][i]="FF";
   }
   Open_UART(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Otev1Click(TObject *Sender)
{
FILE *soubor;
String pomoc;
//int i=0;
int pocet;
int adresa;
int parita;
bool error=0;

for(int j=0;j<=16384;j++)
   pole[j]=255;

 if (Open->Execute()==true)
  {
        soubor=fopen(Open->FileName.c_str(),"rt");
        char znak;
        while ((getc(soubor))!=EOF)
        {
          pomoc="";
          fseek(soubor,-1,SEEK_CUR);
          znak=getc(soubor);
          if (znak==':') //nalezen zatku dku
          {
             znak=getc(soubor);
             pomoc=pomoc+znak;
             znak=getc(soubor);
             pomoc=pomoc+znak;
             pocet=Prevod_deka(16,pomoc); //zjitn potu adres na dku
          }
          if (pocet==0) //konec souboru
             break;
          pomoc="";
          znak=getc(soubor);
          pomoc=pomoc+znak;
          znak=getc(soubor);
          pomoc=pomoc+znak;
          znak=getc(soubor);
          pomoc=pomoc+znak;
          znak=getc(soubor);
          pomoc=pomoc+znak;
          adresa=Prevod_deka(16,pomoc); //zjitn adresy, na kter dek zan
          parita=0;
          getc(soubor);
          getc(soubor);
          for(int j=1;j<=pocet;j++) //oven parity souboru
          {
             pomoc="";
             znak=getc(soubor);
             pomoc=pomoc+znak;
             znak=getc(soubor);
             pomoc=pomoc+znak;
             pole[adresa+j-1]=Prevod_deka(16,pomoc);
             parita=parita+pole[adresa+j-1];
          }
          pomoc="";
          znak=getc(soubor);
          pomoc=pomoc+znak;
          znak=getc(soubor);
          pomoc=pomoc+znak;
          parita=parita+Prevod_deka(16,pomoc); //parita se spot jako souet vech dat na dku, adresy a paritnho dvojsl na konci dku
          parita=parita+(adresa/256)+(adresa%256)+pocet;
          if ((parita%256)!=0) // pokud je souet vech paritnch dat dliteln 256 je soubor v podku
          {
             MessageDlg("Neplatn souet natanch dat\nSoubor je pokozen",mtWarning,TMsgDlgButtons()<<mbYes, 0);
             error=1;
             break;
          }
          getc(soubor);
        }
        fclose (soubor);
  }
  if(error==0)
  {
     for(int i=0;i<256;i++)  //zobrazen dat
        for(int j=1;j<18;j++)
           SData->Cells[j][i]=Prevod_ost(pole[j-1+12288+i*16],16);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Konec1Click(TObject *Sender)
{
 Close();  //ukonen programu
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Programuj1Click(TObject *Sender)
{
   int i;
  Form1->Informace->Caption = "Programuji... (cca 10s)";
  i=MessageDlg("Opravdu chcete peprogramovat LVM - 51?",mtWarning,TMsgDlgButtons()<<mbYes<<mbNo, 0);
  if (i==mrYes)
  {

     if (Write_UART((pole+12288),16384)==16384)
         MessageDlg("Programovani probhlo v podku",mtInformation,TMsgDlgButtons()<<mbOK, 0);
     else
        MessageDlg("Chyba pri odesln",mtError,TMsgDlgButtons()<<mbOK, 0);
     Form1->Informace->Caption = "";
  }
  else
     Form1->Informace->Caption = "Programovn zrueno";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vytvoil1Click(TObject *Sender)
{
MessageDlg("Jako soust diplomov prce \nvytvoil Michal Jeek VUT Brno 2007. ",mtInformation,TMsgDlgButtons()<<mbOK, 0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------








void __fastcall TForm1::port2Click(TObject *Sender)
{
   port1->Enabled=true;
   port2->Enabled=false;
   port3->Enabled=true;
   port4->Enabled=true;
   port5->Enabled=true;
   CloseHandle(hCOM);
   Open_UART(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::port1Click(TObject *Sender)
{
   port1->Enabled=false;
   port2->Enabled=true;
   port3->Enabled=true;
   port4->Enabled=true;
   port5->Enabled=true;
   CloseHandle(hCOM);
   Open_UART(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::port3Click(TObject *Sender)
{
   port1->Enabled=true;
   port2->Enabled=true;
   port3->Enabled=false;
   port4->Enabled=true;
   port5->Enabled=true;
   CloseHandle(hCOM);
   Open_UART(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::port4Click(TObject *Sender)
{
   port1->Enabled=true;
   port2->Enabled=true;
   port3->Enabled=true;
   port4->Enabled=false;
   port5->Enabled=true;
   CloseHandle(hCOM);
   Open_UART(3);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::port5Click(TObject *Sender)
{
   port1->Enabled=true;
   port2->Enabled=true;
   port3->Enabled=true;
   port4->Enabled=true;
   port5->Enabled=false;
   CloseHandle(hCOM);
   Open_UART(4);
}
//---------------------------------------------------------------------------

